shader_type spatial;
render_mode unshaded, cull_disabled, skip_vertex_transform;

uniform float speed = 10.0;
uniform float gravity = 9.8;
uniform float total_time = 10.0;
uniform vec4 mix_color : hint_color;
uniform sampler2D arrow_texture : hint_albedo;

void vertex() {
	float current_time = (VERTEX.z + 50.0) / 100.0 * total_time;
	VERTEX.z = -speed * current_time;
	
	VERTEX = (WORLD_MATRIX * vec4(VERTEX, 1.0)).xyz; 
	
	vec3 offset = vec3(0.0, 0.0, -speed) * current_time + 0.5 * vec3(0.0, -gravity, 0.0) * current_time * current_time;
	VERTEX.y += offset.y;
	
	VERTEX = (INV_CAMERA_MATRIX * vec4(VERTEX, 1.0)).xyz;
}

void fragment() {
	float offset = TIME * 2.0;
	vec4 col = texture(arrow_texture, vec2(UV.x, offset - UV.y * total_time * speed * 4.0)).rgba;
	ALBEDO = col.rgb * mix_color.rgb;
	
	ALPHA = col.a;
}
